/*	
	Percentuali 0.3 Author: Paolo Grifantini 2012-03-28
	Contact: paolo.grifantini@gmail.com
	
	Copyright Paolo Grifantini, 2006-2012
	
	Distributed under a Creative Commons License
	Attribution-NonCommercial-NoDerivs 2.5
	
	You are free:
	*	to copy, distribute, display, and perform the work
	
	Under the following conditions:
	* Attribution. You must attribute the work in the manner specified by the author or licensor.
	* Noncommercial. You may not use this work for commercial purposes.
	* No Derivative Works. You may not alter, transform, or build upon this work.
	
	For any reuse or distribution, you must make clear to others the license terms of this work.
	Any of these conditions can be waived if you get permission from the copyright holder.
	
	Your fair use and other rights are in no way affected by the above.	
*/

/* remaining bugs


*/

/* to do

*/

/* done


*/

var flipShown = false;
var updateShown = false;

var array_elements = ['','','','0','x','6']; // valori di default

function onhidden ()
{
	//saveConversionToPreferences();
}

if (window.widget)
{
	widget.onhide = onhidden;
}

if (window.widget) 
{
	widget.onshow = onshow;
}

window.onload = init;

var current_version = "0.3";

var there_is_a_new_version = false;

var error_retrieving = false;
var retrieve_data_done = 0;

var decimal_separator = ".";
var thousand_separator = ",";

var dataPrecision = 6;
var currentArrow = 0;
var currentOperator = "x";

var show_ad = true;

function onshow()
{
	
}

function clean_for_new_version()
{
	widget.setPreferenceForKey ("", "saved_values");
}

function init()
{
	//cleaner(); /* clean preferences for debug purposes */
	//clean_for_new_version();
	
	content=document.getElementById('front');
	
	content.addEventListener('mousemove',mousemove,false);
	content.addEventListener('mouseout',mouseexit,false);
	
	document.getElementById('flip').style.opacity = "0.0";
	
	setTimeout("version_check();", 20*1000);
	setInterval("version_check();",24*60*60*1000); // ogni 24h faccio il controllo
	
	init_values_from_prefs();
	
	separators = RoundPlugin.getSeparators();
	thousand_separator = separators.charAt(0);
	decimal_separator = separators.charAt(1);
	
	initBack();
}

function init_values_from_prefs()
{
	read_values();
	
	quantity.value = (array_elements[0] == "")?array_elements[0]:RoundPlugin.getFormattedValue(array_elements[0].toString(),"false",dataPrecision);
	percentage.value = (array_elements[1] == "")?array_elements[1]:RoundPlugin.getFormattedValue(array_elements[1].toString(),"false",dataPrecision);
	result.value = (array_elements[2] == "")?array_elements[2]:RoundPlugin.getFormattedValue(array_elements[2].toString(),"false",dataPrecision);
	
	currentArrow = parseInt(array_elements[3]);
	setArrow(currentArrow);
	
	currentOperator = array_elements[4];
	
	if (currentOperator == "x") {operator.options[0].selected = true;} else if (currentOperator == "+") {operator.options[1].selected = true;} else if (currentOperator == "-") {operator.options[2].selected = true;}
	if (currentOperator == "x") {operator_label.setAttribute("style", "background: url('mult.png') no-repeat;")} else if (currentOperator == "+") {operator_label.setAttribute("style", "background: url('add.png') no-repeat;")} else if (currentOperator == "-") {operator_label.setAttribute("style", "background: url('sub.png') no-repeat;")}
	
	dataPrecision = (array_elements[5] == "")?6:parseInt(array_elements[5]);
	precision_popup.options[dataPrecision-1].selected = true;
}

function initBack()
{
	precisionLabel.innerHTML = getLocalizedString('precisionPrefs');
	author.innerHTML = getLocalizedString('author');
    
    show_ad = widget.preferenceForKey(createkey("showad"));
	if (isNotInizialized(show_ad)) {
		show_ad = widget.preferenceForKey("showad");
		if (isNotInizialized(show_ad)) {show_ad = true;} else {show_ad = (show_ad == "true")?true:false}
	} else {show_ad = (show_ad == "true")?true:false}
    
    hide_ad_check.checked = !show_ad;
    
    if (show_ad) {
        document.getElementById('adLabel').style.display = "block";
    } else {
        document.getElementById('adLabel').style.display = "none";
    }
    
    document.getElementById('adLabel').innerHTML = getLocalizedString('adLabel');

	var doneButton = document.getElementById('done');
	createGenericButton (doneButton, getLocalizedString('Done'), selectDone);
	
	var donateButton = document.getElementById('donate');
	createGenericButton (donateButton, getLocalizedString('Donate'), selectDonate);
	
	doneButton.childNodes[1].style.minWidth = '47px';
}

//****************************************************************************************************************
//
// calculations functions
//
//****************************************************************************************************************

function calculate()
{
	var empty_fields = 0;
	var empty_field;
	
	if (isNotInizialized(quantity.value)) {empty_fields++; empty_field = 1;}
	if (isNotInizialized(percentage.value)) {empty_fields++; empty_field = 2;}
	if (isNotInizialized(result.value)) {empty_fields++; empty_field = 3;}
	
	selected_operator = operator.options[operator.selectedIndex].value;
	
	if (empty_fields > 1) return;
	
	the_quantity = RoundPlugin.getNumericValue(quantity.value);
	the_percentage = RoundPlugin.getNumericValue(percentage.value);
	the_result = RoundPlugin.getNumericValue(result.value);
	
	if (empty_fields == 1){
		switch (empty_field){
			case 1:
				if (selected_operator == "x") {the_quantity = (the_result * 100 / the_percentage)} else if (selected_operator == "+") {the_quantity = (the_result * 100 / (100 + (+the_percentage)))} else if (selected_operator == "-") {the_quantity = (the_result * 100 / (100 - the_percentage))}; quantity.value = RoundPlugin.getFormattedValue(the_quantity.toString(),"false",dataPrecision); setArrow(1); break;
			case 2:
				if (selected_operator == "x") {the_percentage = (the_result * 100 / the_quantity)} else if (selected_operator == "+") {the_percentage = (the_result*100/the_quantity) - 100} else if (selected_operator == "-") {the_percentage = (100 - (the_result*100/the_quantity))}; percentage.value = RoundPlugin.getFormattedValue(the_percentage.toString(),"false",dataPrecision); setArrow(2); break;
			case 3:
				if (selected_operator == "x") {the_result = (the_quantity * the_percentage / 100)} else if (selected_operator == "+") {the_result = ((+the_quantity) + (the_quantity * the_percentage / 100))} else if (selected_operator == "-") {the_result = the_quantity - (the_quantity * the_percentage / 100)}; result.value = RoundPlugin.getFormattedValue(the_result.toString(),"false",dataPrecision); setArrow(3); break;
		}
	}
	
	if (empty_fields == 0){
		switch (currentArrow){
			case 1:
				if (selected_operator == "x") {the_quantity = (the_result * 100 / the_percentage)} else if (selected_operator == "+") {the_quantity = (the_result * 100 / (100 + (+the_percentage)))} else if (selected_operator == "-") {the_quantity = (the_result * 100 / (100 - the_percentage))}; quantity.value = RoundPlugin.getFormattedValue(the_quantity.toString(),"false",dataPrecision); break;
			case 2:
				if (selected_operator == "x") {the_percentage = (the_result * 100 / the_quantity)} else if (selected_operator == "+") {the_percentage = (the_result*100/the_quantity) - 100} else if (selected_operator == "-") {the_percentage = (100 - (the_result*100/the_quantity))}; percentage.value = RoundPlugin.getFormattedValue(the_percentage.toString(),"false",dataPrecision); break;
			case 3:
				if (selected_operator == "x") {the_result = (the_quantity * the_percentage / 100)} else if (selected_operator == "+") {the_result = ((+the_quantity) + (the_quantity * the_percentage / 100))} else if (selected_operator == "-") {the_result = the_quantity - (the_quantity * the_percentage / 100)}; result.value = RoundPlugin.getFormattedValue(the_result.toString(),"false",dataPrecision); break;
		}
	}
	
	array_elements[0] = the_quantity;
	array_elements[1] = the_percentage;
	array_elements[2] = the_result;
	
	save_values();
}

function setArrow(which_arrow)
{
	(which_arrow == 1)?document.getElementById('arrow1').style.opacity = "1.0":document.getElementById('arrow1').style.opacity = "0.1";
	(which_arrow == 2)?document.getElementById('arrow2').style.opacity = "1.0":document.getElementById('arrow2').style.opacity = "0.1";
	(which_arrow == 3)?document.getElementById('arrow3').style.opacity = "1.0":document.getElementById('arrow3').style.opacity = "0.1";
	
	currentArrow = which_arrow;
	array_elements[3] = currentArrow;
	save_values();
}

function operatorChanged()
{
	selected_operator = operator.options[operator.selectedIndex].value;

	if (selected_operator == "x") {operator_label.setAttribute("style", "background: url('mult.png') no-repeat;")} else if (selected_operator == "+") {operator_label.setAttribute("style", "background: url('add.png') no-repeat;")} else if (selected_operator == "-") {operator_label.setAttribute("style", "background: url('sub.png') no-repeat;")}
	
	calculate();
	
	array_elements[4] = selected_operator;
	save_values();
}

function reset_fields()
{
	quantity.value = "";
	percentage.value = "";
	result.value = "";
	
	document.getElementById('arrow1').style.opacity = "0.1";
	document.getElementById('arrow2').style.opacity = "0.1";
	document.getElementById('arrow3').style.opacity = "0.1";
	
	array_elements[0] = "";
	array_elements[1] = "";
	array_elements[2] = "";
	array_elements[3] = "";
	
	save_values();
}

function change_precision(){
	dataPrecision = precision_popup.options[precision_popup.selectedIndex].value;
	array_elements[5] = dataPrecision;
	save_values();
	calculate();
}

//****************************************************************************************************************
//
// Prefs saving functions
//
//****************************************************************************************************************

function createkey(key)
{
	return widget.identifier + "-" + key;
}

function createArrayElementsJSString(thearray)
{
	var str = "["
	var c = thearray.length;
	
	for (var i = 0; i < c; ++i)
	{
		str += "'" + thearray[i] + "'";
		if (i != c-1) str += ",";
	}
	
	str += "];";
	
	return str;
}

function save_values()
{
	if (window.widget)
	{
		array_values = createArrayElementsJSString(array_elements);
		
		widget.setPreferenceForKey (array_values, createkey("saved_values"));
		widget.setPreferenceForKey (array_values, "saved_values");
	}
}

function read_values()
{
	if (window.widget)
	{
		try{
			var local_data = widget.preferenceForKey (createkey("saved_values"));
			if (!(isNotInizialized(local_data))){
				data = eval(local_data);
				
				if (data.length != 0) {
					array_elements = data;
					return;
				}
			}
		} catch(e) {
			
		}
		
		try{
			var global_data = widget.preferenceForKey ("saved_values");
			if (!(isNotInizialized(global_data))){
				data = eval(global_data);
				
				if (data.length != 0) {
					array_elements = data;
					return;
				}
			}
		} catch(e) {
			
		}
		
		array_elements = ['','','','0','x','6'];
	}
}


//****************************************************************************************************************
//
// Utility functions
//
//****************************************************************************************************************

function numeralsOnly(allTheData_element,evt)
{ 
    if (evt.metaKey) {// command key down
    	return true;// process for meta key being down
	}
    
    evt = (evt) ? evt : event;
    var charCode = (evt.charCode) ? evt.charCode : ((evt.keyCode) ? evt.keyCode : ((evt.which) ? evt.which : 0));
    
    //RoundPlugin.logMessage(charCode);
    if (charCode == 9) { // tab key
    	var new_element;
    	if (allTheData_element == table_elements.length - 1) {new_element = 0;} else {new_element = allTheData_element + 1;}
    	document.getElementById("value_field_" + new_element).focus();
    	return false;
    } else if (charCode == 25) { // shift-tab key
    	var new_element;
    	if (allTheData_element == 0) {new_element = table_elements.length - 1;} else {new_element = allTheData_element - 1;}
    	document.getElementById("value_field_" + new_element).focus();
    	return false;
    } else if (!((charCode < 32 ) || (charCode > 47 && charCode < 58) || (charCode == decimal_separator.charCodeAt()) || (charCode == thousand_separator.charCodeAt()) || (charCode == 63272) || ((charCode >= 63232) && (charCode <= 63235)))) {
        return false;
    } else if (charCode == 13 || charCode == 3) { // enter keys
		return false;
    }
    
    return true;
}

function verify_calculate()
{
	calculate();
}

function isNotInizialized(the_var)
{
	if ((the_var == undefined) || (the_var == "") || (the_var == "undefined") || (the_var == null)) return true;
	return false;
}

function getLocalizedString (key)
{
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}
	
	return key;
}

//****************************************************************************************************************
//
// Functions to handle version check
//
//****************************************************************************************************************

var version_req_stop_timeout = false;
var version_req_timeout = false;

function loadVersionPage(url)
{
	if (window.XMLHttpRequest) {
		version_req = new XMLHttpRequest();
		version_req.onreadystatechange = parseVersionPage;
		version_req.overrideMimeType("text/xml");
		version_req.setRequestHeader("Cache-Control", "no-cache")
		version_req.open("GET", url, true);
		version_req.send(null);
		
		version_req_stop_timeout = false;
		version_req_timeout = false;
		setTimeout("version_req_send_timeout();",5000);
	}
}

function version_req_send_timeout()
{
	if (version_req_stop_timeout){return;}
	version_req_timeout = true;
}

function isGreaterVersion(release1, release2)
{
	// faccio uno split per il '.' e poi verifico valore per valore
	release1_numbers = release1.split('.');
	release2_numbers = release2.split('.');
	
	release1_value = 0;
	release2_value = 0;
	
	// risolvo matematicamente che è più elegante...
	
	for (i=0;i<release1_numbers.length;i++){
		release1_value += release1_numbers[i]*(Math.pow(10,-i*3));
	}
	
	for (i=0;i<release2_numbers.length;i++){
		release2_value += release2_numbers[i]*(Math.pow(10,-i*3));
	}
	
	if (release1_value > release2_value) return true;
	
	return false;
}

function parseVersionPage()
{
	if (version_req_timeout) {version_req.abort(); version_req_timeout = false; version_req_stop_timeout = true; return;}
	
	if ((version_req.readyState == 4) && (version_req.status == 200)) {
		version_req_stop_timeout = true;
		version_req_timeout = false;
		
		latest_version = version_req.responseXML.getElementsByTagName("version");
		latest_version = latest_version[0].firstChild.data;
		
		if (isGreaterVersion(latest_version,current_version)){
			there_is_a_new_version = true;
		}
		//debug (latest_version);
		
		if (there_is_a_new_version) {
			new_version_badge.style.display = "block"
			new_version_badge.setAttribute ("title", getLocalizedString('new_version_tooltip'));
		}
	}
}

function version_check()
{
	loadVersionPage('http://www.palple.net/widgets/percentuali/version.xml');
}



//****************************************************************************************************************
//
// Functions to handle backside & flipper
//
//****************************************************************************************************************

function switch_ad_check()
{
	if (hide_ad_check.checked){
		hide_ad_check.checked = false;
	} else {
		hide_ad_check.checked = true;
	}
}

var actual_size = 79;

function goToStore()
{
 	widget.openURL("http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewSoftware?id=307586236&mt=8");
}

function goToMySite()
{
 	widget.openURL(getLocalizedString('web_page_url'));
}

function selectDonate ()
{
	widget.openURL(getLocalizedString('web_page_url_donate'));
}

function goToDownloadPage()
{
	// vai al sito
	widget.openURL("http://www.palple.net/widgets/percentages/Percentages.zip");
}

function selectDone ()
{
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
    
    show_ad = !hide_ad_check.checked;
    
    widget.setPreferenceForKey(show_ad.toString(),createkey("showad"));
	widget.setPreferenceForKey(show_ad.toString(),"showad");
    
    if (show_ad) {
        document.getElementById('adLabel').style.display = "block";
    } else {
        document.getElementById('adLabel').style.display = "none";
    }
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	
	flipShown = true;

	if (there_is_a_new_version) new_version_badge.style.display = 'block';
}

function flipover()
{	
	if (document.getElementById("behind").style.display=='block'){
		finishwithback();
	}else{
		showbackside();
	}
}

function finishwithback()
{
	showfrontside();
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}


// The following code is copyright Apple Computer Inc.;

function showbackside()
{
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
	
	new_version_badge.style.display = 'none';
	
	resizedWhenFlippedOver = false;
	if (window.widget)
	{	
		if (actual_size < 119){
			resizedWhenFlippedOver = true;
			window.resizeTo (340, 119);
		}
		
		widget.prepareForTransition("ToBack");
	}
	
	front.style.display="none";
	back.style.display="block";
	
	document.getElementById('fliprollie').style.display = 'none';
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	
}

function showfrontside()
{
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
	
	resizedWhenFlippedOver = false;
	if (window.widget)
	{	
		if (119 < actual_size){
			resizedWhenFlippedOver = true;
			window.resizeTo (340, actual_size);
		}
		
		widget.prepareForTransition("ToFront");
	}
	
	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout("widget.performTransition();", 0);
	
	if (there_is_a_new_version) new_version_badge.style.display = 'block';
}


var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};
var animation_update = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration){
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
}

function mousemove()
{
	if (!flipShown){
		// fade in the flip widget
		if (animation.timer != null){
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit()
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}